package com.lightinit.hsdataplatformresdir.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class PublishInfoExample extends BaseExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public PublishInfoExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andResourceIdIsNull() {
            addCriterion("resource_id is null");
            return (Criteria) this;
        }

        public Criteria andResourceIdIsNotNull() {
            addCriterion("resource_id is not null");
            return (Criteria) this;
        }

        public Criteria andResourceIdEqualTo(Long value) {
            addCriterion("resource_id =", value, "resourceId");
            return (Criteria) this;
        }

        public Criteria andResourceIdNotEqualTo(Long value) {
            addCriterion("resource_id <>", value, "resourceId");
            return (Criteria) this;
        }

        public Criteria andResourceIdGreaterThan(Long value) {
            addCriterion("resource_id >", value, "resourceId");
            return (Criteria) this;
        }

        public Criteria andResourceIdGreaterThanOrEqualTo(Long value) {
            addCriterion("resource_id >=", value, "resourceId");
            return (Criteria) this;
        }

        public Criteria andResourceIdLessThan(Long value) {
            addCriterion("resource_id <", value, "resourceId");
            return (Criteria) this;
        }

        public Criteria andResourceIdLessThanOrEqualTo(Long value) {
            addCriterion("resource_id <=", value, "resourceId");
            return (Criteria) this;
        }

        public Criteria andResourceIdIn(List<Long> values) {
            addCriterion("resource_id in", values, "resourceId");
            return (Criteria) this;
        }

        public Criteria andResourceIdNotIn(List<Long> values) {
            addCriterion("resource_id not in", values, "resourceId");
            return (Criteria) this;
        }

        public Criteria andResourceIdBetween(Long value1, Long value2) {
            addCriterion("resource_id between", value1, value2, "resourceId");
            return (Criteria) this;
        }

        public Criteria andResourceIdNotBetween(Long value1, Long value2) {
            addCriterion("resource_id not between", value1, value2, "resourceId");
            return (Criteria) this;
        }

        public Criteria andPublishStateIsNull() {
            addCriterion("publish_state is null");
            return (Criteria) this;
        }

        public Criteria andPublishStateIsNotNull() {
            addCriterion("publish_state is not null");
            return (Criteria) this;
        }

        public Criteria andPublishStateEqualTo(String value) {
            addCriterion("publish_state =", value, "publishState");
            return (Criteria) this;
        }

        public Criteria andPublishStateNotEqualTo(String value) {
            addCriterion("publish_state <>", value, "publishState");
            return (Criteria) this;
        }

        public Criteria andPublishStateGreaterThan(String value) {
            addCriterion("publish_state >", value, "publishState");
            return (Criteria) this;
        }

        public Criteria andPublishStateGreaterThanOrEqualTo(String value) {
            addCriterion("publish_state >=", value, "publishState");
            return (Criteria) this;
        }

        public Criteria andPublishStateLessThan(String value) {
            addCriterion("publish_state <", value, "publishState");
            return (Criteria) this;
        }

        public Criteria andPublishStateLessThanOrEqualTo(String value) {
            addCriterion("publish_state <=", value, "publishState");
            return (Criteria) this;
        }

        public Criteria andPublishStateLike(String value) {
            addCriterion("publish_state like", value, "publishState");
            return (Criteria) this;
        }

        public Criteria andPublishStateNotLike(String value) {
            addCriterion("publish_state not like", value, "publishState");
            return (Criteria) this;
        }

        public Criteria andPublishStateIn(List<String> values) {
            addCriterion("publish_state in", values, "publishState");
            return (Criteria) this;
        }

        public Criteria andPublishStateNotIn(List<String> values) {
            addCriterion("publish_state not in", values, "publishState");
            return (Criteria) this;
        }

        public Criteria andPublishStateBetween(String value1, String value2) {
            addCriterion("publish_state between", value1, value2, "publishState");
            return (Criteria) this;
        }

        public Criteria andPublishStateNotBetween(String value1, String value2) {
            addCriterion("publish_state not between", value1, value2, "publishState");
            return (Criteria) this;
        }

        public Criteria andDataTagIsNull() {
            addCriterion("data_tag is null");
            return (Criteria) this;
        }

        public Criteria andDataTagIsNotNull() {
            addCriterion("data_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDataTagEqualTo(String value) {
            addCriterion("data_tag =", value, "dataTag");
            return (Criteria) this;
        }

        public Criteria andDataTagNotEqualTo(String value) {
            addCriterion("data_tag <>", value, "dataTag");
            return (Criteria) this;
        }

        public Criteria andDataTagGreaterThan(String value) {
            addCriterion("data_tag >", value, "dataTag");
            return (Criteria) this;
        }

        public Criteria andDataTagGreaterThanOrEqualTo(String value) {
            addCriterion("data_tag >=", value, "dataTag");
            return (Criteria) this;
        }

        public Criteria andDataTagLessThan(String value) {
            addCriterion("data_tag <", value, "dataTag");
            return (Criteria) this;
        }

        public Criteria andDataTagLessThanOrEqualTo(String value) {
            addCriterion("data_tag <=", value, "dataTag");
            return (Criteria) this;
        }

        public Criteria andDataTagLike(String value) {
            addCriterion("data_tag like", value, "dataTag");
            return (Criteria) this;
        }

        public Criteria andDataTagNotLike(String value) {
            addCriterion("data_tag not like", value, "dataTag");
            return (Criteria) this;
        }

        public Criteria andDataTagIn(List<String> values) {
            addCriterion("data_tag in", values, "dataTag");
            return (Criteria) this;
        }

        public Criteria andDataTagNotIn(List<String> values) {
            addCriterion("data_tag not in", values, "dataTag");
            return (Criteria) this;
        }

        public Criteria andDataTagBetween(String value1, String value2) {
            addCriterion("data_tag between", value1, value2, "dataTag");
            return (Criteria) this;
        }

        public Criteria andDataTagNotBetween(String value1, String value2) {
            addCriterion("data_tag not between", value1, value2, "dataTag");
            return (Criteria) this;
        }

        public Criteria andPublishChannelIsNull() {
            addCriterion("publish_channel is null");
            return (Criteria) this;
        }

        public Criteria andPublishChannelIsNotNull() {
            addCriterion("publish_channel is not null");
            return (Criteria) this;
        }

        public Criteria andPublishChannelEqualTo(String value) {
            addCriterion("publish_channel =", value, "publishChannel");
            return (Criteria) this;
        }

        public Criteria andPublishChannelNotEqualTo(String value) {
            addCriterion("publish_channel <>", value, "publishChannel");
            return (Criteria) this;
        }

        public Criteria andPublishChannelGreaterThan(String value) {
            addCriterion("publish_channel >", value, "publishChannel");
            return (Criteria) this;
        }

        public Criteria andPublishChannelGreaterThanOrEqualTo(String value) {
            addCriterion("publish_channel >=", value, "publishChannel");
            return (Criteria) this;
        }

        public Criteria andPublishChannelLessThan(String value) {
            addCriterion("publish_channel <", value, "publishChannel");
            return (Criteria) this;
        }

        public Criteria andPublishChannelLessThanOrEqualTo(String value) {
            addCriterion("publish_channel <=", value, "publishChannel");
            return (Criteria) this;
        }

        public Criteria andPublishChannelLike(String value) {
            addCriterion("publish_channel like", value, "publishChannel");
            return (Criteria) this;
        }

        public Criteria andPublishChannelNotLike(String value) {
            addCriterion("publish_channel not like", value, "publishChannel");
            return (Criteria) this;
        }

        public Criteria andPublishChannelIn(List<String> values) {
            addCriterion("publish_channel in", values, "publishChannel");
            return (Criteria) this;
        }

        public Criteria andPublishChannelNotIn(List<String> values) {
            addCriterion("publish_channel not in", values, "publishChannel");
            return (Criteria) this;
        }

        public Criteria andPublishChannelBetween(String value1, String value2) {
            addCriterion("publish_channel between", value1, value2, "publishChannel");
            return (Criteria) this;
        }

        public Criteria andPublishChannelNotBetween(String value1, String value2) {
            addCriterion("publish_channel not between", value1, value2, "publishChannel");
            return (Criteria) this;
        }

        public Criteria andAuditedByIsNull() {
            addCriterion("audited_by is null");
            return (Criteria) this;
        }

        public Criteria andAuditedByIsNotNull() {
            addCriterion("audited_by is not null");
            return (Criteria) this;
        }

        public Criteria andAuditedByEqualTo(Long value) {
            addCriterion("audited_by =", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByNotEqualTo(Long value) {
            addCriterion("audited_by <>", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByGreaterThan(Long value) {
            addCriterion("audited_by >", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByGreaterThanOrEqualTo(Long value) {
            addCriterion("audited_by >=", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByLessThan(Long value) {
            addCriterion("audited_by <", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByLessThanOrEqualTo(Long value) {
            addCriterion("audited_by <=", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByIn(List<Long> values) {
            addCriterion("audited_by in", values, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByNotIn(List<Long> values) {
            addCriterion("audited_by not in", values, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByBetween(Long value1, Long value2) {
            addCriterion("audited_by between", value1, value2, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByNotBetween(Long value1, Long value2) {
            addCriterion("audited_by not between", value1, value2, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedAtIsNull() {
            addCriterion("audited_at is null");
            return (Criteria) this;
        }

        public Criteria andAuditedAtIsNotNull() {
            addCriterion("audited_at is not null");
            return (Criteria) this;
        }

        public Criteria andAuditedAtEqualTo(Date value) {
            addCriterion("audited_at =", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtNotEqualTo(Date value) {
            addCriterion("audited_at <>", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtGreaterThan(Date value) {
            addCriterion("audited_at >", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("audited_at >=", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtLessThan(Date value) {
            addCriterion("audited_at <", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtLessThanOrEqualTo(Date value) {
            addCriterion("audited_at <=", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtIn(List<Date> values) {
            addCriterion("audited_at in", values, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtNotIn(List<Date> values) {
            addCriterion("audited_at not in", values, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtBetween(Date value1, Date value2) {
            addCriterion("audited_at between", value1, value2, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtNotBetween(Date value1, Date value2) {
            addCriterion("audited_at not between", value1, value2, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditResultIsNull() {
            addCriterion("audit_result is null");
            return (Criteria) this;
        }

        public Criteria andAuditResultIsNotNull() {
            addCriterion("audit_result is not null");
            return (Criteria) this;
        }

        public Criteria andAuditResultEqualTo(String value) {
            addCriterion("audit_result =", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotEqualTo(String value) {
            addCriterion("audit_result <>", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultGreaterThan(String value) {
            addCriterion("audit_result >", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultGreaterThanOrEqualTo(String value) {
            addCriterion("audit_result >=", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultLessThan(String value) {
            addCriterion("audit_result <", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultLessThanOrEqualTo(String value) {
            addCriterion("audit_result <=", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultLike(String value) {
            addCriterion("audit_result like", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotLike(String value) {
            addCriterion("audit_result not like", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultIn(List<String> values) {
            addCriterion("audit_result in", values, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotIn(List<String> values) {
            addCriterion("audit_result not in", values, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultBetween(String value1, String value2) {
            addCriterion("audit_result between", value1, value2, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotBetween(String value1, String value2) {
            addCriterion("audit_result not between", value1, value2, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionIsNull() {
            addCriterion("audit_opinion is null");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionIsNotNull() {
            addCriterion("audit_opinion is not null");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionEqualTo(String value) {
            addCriterion("audit_opinion =", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotEqualTo(String value) {
            addCriterion("audit_opinion <>", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionGreaterThan(String value) {
            addCriterion("audit_opinion >", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionGreaterThanOrEqualTo(String value) {
            addCriterion("audit_opinion >=", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionLessThan(String value) {
            addCriterion("audit_opinion <", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionLessThanOrEqualTo(String value) {
            addCriterion("audit_opinion <=", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionLike(String value) {
            addCriterion("audit_opinion like", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotLike(String value) {
            addCriterion("audit_opinion not like", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionIn(List<String> values) {
            addCriterion("audit_opinion in", values, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotIn(List<String> values) {
            addCriterion("audit_opinion not in", values, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionBetween(String value1, String value2) {
            addCriterion("audit_opinion between", value1, value2, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotBetween(String value1, String value2) {
            addCriterion("audit_opinion not between", value1, value2, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(Long value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(Long value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(Long value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(Long value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(Long value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(Long value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<Long> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<Long> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(Long value1, Long value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(Long value1, Long value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(Long value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(Long value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(Long value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(Long value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(Long value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(Long value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<Long> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<Long> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(Long value1, Long value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(Long value1, Long value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andOutId1IsNull() {
            addCriterion("out_id_1 is null");
            return (Criteria) this;
        }

        public Criteria andOutId1IsNotNull() {
            addCriterion("out_id_1 is not null");
            return (Criteria) this;
        }

        public Criteria andOutId1EqualTo(String value) {
            addCriterion("out_id_1 =", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1NotEqualTo(String value) {
            addCriterion("out_id_1 <>", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1GreaterThan(String value) {
            addCriterion("out_id_1 >", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1GreaterThanOrEqualTo(String value) {
            addCriterion("out_id_1 >=", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1LessThan(String value) {
            addCriterion("out_id_1 <", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1LessThanOrEqualTo(String value) {
            addCriterion("out_id_1 <=", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1Like(String value) {
            addCriterion("out_id_1 like", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1NotLike(String value) {
            addCriterion("out_id_1 not like", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1In(List<String> values) {
            addCriterion("out_id_1 in", values, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1NotIn(List<String> values) {
            addCriterion("out_id_1 not in", values, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1Between(String value1, String value2) {
            addCriterion("out_id_1 between", value1, value2, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1NotBetween(String value1, String value2) {
            addCriterion("out_id_1 not between", value1, value2, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId2IsNull() {
            addCriterion("out_id_2 is null");
            return (Criteria) this;
        }

        public Criteria andOutId2IsNotNull() {
            addCriterion("out_id_2 is not null");
            return (Criteria) this;
        }

        public Criteria andOutId2EqualTo(String value) {
            addCriterion("out_id_2 =", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2NotEqualTo(String value) {
            addCriterion("out_id_2 <>", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2GreaterThan(String value) {
            addCriterion("out_id_2 >", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2GreaterThanOrEqualTo(String value) {
            addCriterion("out_id_2 >=", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2LessThan(String value) {
            addCriterion("out_id_2 <", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2LessThanOrEqualTo(String value) {
            addCriterion("out_id_2 <=", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2Like(String value) {
            addCriterion("out_id_2 like", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2NotLike(String value) {
            addCriterion("out_id_2 not like", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2In(List<String> values) {
            addCriterion("out_id_2 in", values, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2NotIn(List<String> values) {
            addCriterion("out_id_2 not in", values, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2Between(String value1, String value2) {
            addCriterion("out_id_2 between", value1, value2, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2NotBetween(String value1, String value2) {
            addCriterion("out_id_2 not between", value1, value2, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId3IsNull() {
            addCriterion("out_id_3 is null");
            return (Criteria) this;
        }

        public Criteria andOutId3IsNotNull() {
            addCriterion("out_id_3 is not null");
            return (Criteria) this;
        }

        public Criteria andOutId3EqualTo(String value) {
            addCriterion("out_id_3 =", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3NotEqualTo(String value) {
            addCriterion("out_id_3 <>", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3GreaterThan(String value) {
            addCriterion("out_id_3 >", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3GreaterThanOrEqualTo(String value) {
            addCriterion("out_id_3 >=", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3LessThan(String value) {
            addCriterion("out_id_3 <", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3LessThanOrEqualTo(String value) {
            addCriterion("out_id_3 <=", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3Like(String value) {
            addCriterion("out_id_3 like", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3NotLike(String value) {
            addCriterion("out_id_3 not like", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3In(List<String> values) {
            addCriterion("out_id_3 in", values, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3NotIn(List<String> values) {
            addCriterion("out_id_3 not in", values, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3Between(String value1, String value2) {
            addCriterion("out_id_3 between", value1, value2, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3NotBetween(String value1, String value2) {
            addCriterion("out_id_3 not between", value1, value2, "outId3");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}